/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.51 Revision 1.70
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.51 2007/10/08 14:58:14 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.70 2009/10/08 08:12:50 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
9# vdr-plugin.eclass 9# vdr-plugin.eclass
10# 10#
11# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
12# 12#
13 13
14# Example ebuild (vdr-femon): 14# Example ebuild (basic version without patching):
15# 15#
16# EAPI="2"
16# inherit vdr-plugin 17# inherit vdr-plugin
17# IUSE="" 18# IUSE=""
18# SLOT="0" 19# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)" 20# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/" 21# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz" 22# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2" 23# LICENSE="GPL-2"
23# KEYWORDS="~x86" 24# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27" 25# DEPEND=">=media-video/vdr-1.6.0"
25# 26#
26# 27#
28
29# For patching you should modify src_prepare phase:
30#
31# src_prepare() {
32# epatch "${FILESDIR}"/${P}-xxx.patch
33# vdr-plugin_src_prepare
34# }
27 35
28# Installation of a config file for the plugin 36# Installation of a config file for the plugin
29# 37#
30# If ${VDR_CONFD_FILE} is set install this file 38# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists. 39# else install ${FILESDIR}/confd if it exists.
71 79
72# works in most cases 80# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 81S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 82
75# depend on headers for DVB-driver 83# depend on headers for DVB-driver
76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8 84COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 ) 85
78 >=app-admin/eselect-vdr-0.0.2 86DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 87 media-tv/linuxtv-dvb-headers"
88RDEPEND="${COMMON_DEPEND}
89 >=app-admin/eselect-vdr-0.0.2"
80 90
91# this is a hack for ebuilds like vdr-xineliboutput that want to
92# conditionally install a vdr-plugin
93if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
94 # make DEPEND conditional
95 IUSE="${IUSE} vdr"
96 DEPEND="vdr? ( ${DEPEND} )"
97 RDEPEND="vdr? ( ${RDEPEND} )"
98fi
81 99
82# New method of storing plugindb 100# New method of storing plugindb
83# Called from src_install 101# Called from src_install
84# file maintained by normal portage-methods 102# file maintained by normal portage-methods
85create_plugindb_file() { 103create_plugindb_file() {
86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 104 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}" 105 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
88 insinto "${NEW_VDRPLUGINDB_DIR}" 106 insinto "${NEW_VDRPLUGINDB_DIR}"
107
108# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
89 cat <<-EOT > "${D}/${DB_FILE}" 109# cat <<-EOT > "${D}/${DB_FILE}"
90 VDRPLUGIN_DB=1 110# VDRPLUGIN_DB=1
91 CREATOR=ECLASS 111# CREATOR=ECLASS
92 EBUILD=${CATEGORY}/${PN} 112# EBUILD=${CATEGORY}/${PN}
93 EBUILD_V=${PVR} 113# EBUILD_V=${PVR}
94 EOT 114# EOT
115 {
116 echo "VDRPLUGIN_DB=1"
117 echo "CREATOR=ECLASS"
118 echo "EBUILD=${CATEGORY}/${PN}"
119 echo "EBUILD_V=${PVR}"
120 echo "PLUGINS=\"$@\""
121 } > "${D}/${DB_FILE}"
95} 122}
96 123
97# Delete files created outside of vdr-plugin.eclass 124# Delete files created outside of vdr-plugin.eclass
98# vdrplugin-rebuild.ebuild converted plugindb and files are 125# vdrplugin-rebuild.ebuild converted plugindb and files are
99# not deleted by portage itself - should only be needed as 126# not deleted by portage itself - should only be needed as
122create_header_checksum_file() 149create_header_checksum_file()
123{ 150{
124 # Danger: Not using $ROOT here, as compile will also not use it !!! 151 # Danger: Not using $ROOT here, as compile will also not use it !!!
125 # If vdr in $ROOT and / differ, plugins will not run anyway 152 # If vdr in $ROOT and / differ, plugins will not run anyway
126 153
154 local CHKSUM="header-md5-vdr"
155
156 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
157 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
158 elif type -p md5sum >/dev/null 2>&1; then
159 (
160 cd "${VDR_INCLUDE_DIR}"
161 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
162 ) > "${CHKSUM}"
163 else
164 die "Could not create md5 checksum of headers"
165 fi
166
127 insinto "${VDR_CHECKSUM_DIR}" 167 insinto "${VDR_CHECKSUM_DIR}"
128 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 168 local p_name
129 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}" 169 for p_name; do
170 newins "${CHKSUM}" "header-md5-${p_name}"
171 done
172}
173
174fix_vdr_libsi_include()
175{
176 #einfo "Fixing include of libsi-headers"
177 local f
178 for f; do
179 sed -i "${f}" \
180 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
181 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
182 done
183}
184
185vdr_patchmakefile() {
186 einfo "Patching Makefile"
187 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
188 cp Makefile "${WORKDIR}"/Makefile.before
189
190 # plugin makefiles use VDRDIR in strange ways
191 # assumptions:
192 # 1. $(VDRDIR) contains Make.config
193 # 2. $(VDRDIR) contains config.h
194 # 3. $(VDRDIR)/include/vdr contains the headers
195 # 4. $(VDRDIR) contains main vdr Makefile
196 # 5. $(VDRDIR)/locale exists
197 # 6. $(VDRDIR) allows to access vdr source files
198 #
199 # We only have one directory (for now /usr/include/vdr),
200 # that contains vdr-headers and Make.config.
201 # To satisfy 1-3 we do this:
202 # Set VDRDIR=/usr/include/vdr
203 # Set VDRINCDIR=/usr/include
204 # Change $(VDRDIR)/include to $(VDRINCDIR)
205
206 sed -i Makefile \
207 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
208 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
209 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
210 \
211 -e 's:-I$(DVBDIR)/include::' \
212 -e 's:-I$(DVBDIR)::'
213
214 # maybe needed for multiproto:
215 #sed -i Makefile \
216 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
217 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
218
219 if ! grep -q APIVERSION Makefile; then
220 ebegin " Converting to APIVERSION"
221 sed -i Makefile \
222 -e 's:^APIVERSION = :APIVERSION ?= :' \
223 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
224 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
225 eend $?
226 fi
227
228 # Correcting Compile-Flags
229 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
230 sed -i Makefile \
231 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
232 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
233
234 # Disabling file stripping, useful for debugging
235 sed -i Makefile \
236 -e '/@.*strip/d' \
237 -e '/strip \$(LIBDIR)\/\$@/d' \
238 -e 's/STRIP.*=.*$/STRIP = true/'
239
240 # Use a file instead of a variable as single-stepping via ebuild
241 # destroys environment.
242 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
243}
244
245vdr_add_local_patch() {
246 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
247 echo
248 einfo "Applying local patches"
249 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
250 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
251 done
252 fi
253}
254
255vdr_has_gettext() {
256 has_version ">=media-video/vdr-1.5.7"
257}
258
259plugin_has_gettext() {
260 [[ -d po ]]
261}
262
263vdr_i18n_convert_to_gettext() {
264 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
265
266 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
267 ewarn "Conversion to gettext disabled in ebuild"
268 return 1
269 fi
270
271 if [[ ! -x ${i18n_tool} ]]; then
272 eerror "Missing ${i18n_tool}"
273 eerror "Please re-emerge vdr"
274 die "Missing ${i18n_tool}"
275 fi
276
277 ebegin "Auto converting translations to gettext"
278 # call i18n-to-gettext tool
279 # take all texts missing tr call into special file
280 "${i18n_tool}" 2>/dev/null \
281 |sed -e '/^"/!d' \
282 -e '/^""$/d' \
283 -e 's/\(.*\)/trNOOP(\1)/' \
284 > dummy-translations-trNOOP.c
285
286 # if there were untranslated texts just run it again
287 # now the missing calls are listed in
288 # dummy-translations-trNOOP.c
289 if [[ -s dummy-translations-trNOOP.c ]]; then
290 "${i18n_tool}" &>/dev/null
291 fi
292
293 # now use the modified Makefile
294 if [[ -f Makefile.new ]]; then
295 mv Makefile.new Makefile
296 eend 0 ""
130 else 297 else
131 if type -p md5sum >/dev/null 2>&1; then 298 eend 1 "Conversion to gettext failed. Plugin needs fixing."
132 cd "${S}" 299 return 1
133 ( 300 fi
134 cd "${VDR_INCLUDE_DIR}" 301}
135 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 302
136 ) > header-md5-${PN} 303vdr_i18n_disable_gettext() {
137 doins header-md5-${PN} 304 #einfo "Disabling gettext support in plugin"
305
306 # Remove i18n Target if using older vdr
307 sed -i Makefile \
308 -e '/^all:/s/ i18n//'
309}
310
311vdr_i18n() {
312 if vdr_has_gettext; then
313 #einfo "VDR has gettext support"
314 if plugin_has_gettext; then
315 #einfo "Plugin has gettext support, fine"
316 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
317 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
318 fi
319 else
320 vdr_i18n_convert_to_gettext
321 if [[ $? != 0 ]]; then
322 eerror ""
323 eerror "Plugin will have only english OSD texts"
324 eerror "it needs manual fixing."
325 fi
138 fi 326 fi
327 else
328 #einfo "VDR has no gettext support"
329 if plugin_has_gettext; then
330 vdr_i18n_disable_gettext
139 fi 331 fi
332 fi
140} 333}
334
335vdr-plugin_copy_source_tree() {
336 pushd . >/dev/null
337 cp -r "${S}" "${T}"/source-tree
338 cd "${T}"/source-tree
339 cp "${WORKDIR}"/Makefile.before Makefile
340 # TODO: Fix this, maybe no longer needed
341 sed -i Makefile \
342 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
343 -e 's:^CXXFLAGS:#CXXFLAGS:' \
344 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
345 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
346 popd >/dev/null
347}
348
349vdr-plugin_install_source_tree() {
350 einfo "Installing sources"
351 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
352 insinto "${destdir}-${PV}"
353 doins -r "${T}"/source-tree/*
354
355 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
356}
357
358vdr-plugin_print_enable_command() {
359 local p_name c=0 l=""
360 for p_name in ${vdr_plugin_list}; do
361 c=$(( c+1 ))
362 l="$l ${p_name#vdr-}"
363 done
364
365 elog
366 case $c in
367 1) elog "Installed plugin${l}" ;;
368 *) elog "Installed $c plugins:${l}" ;;
369 esac
370 elog "To activate a plugin execute this command:"
371 elog "\teselect vdr-plugin enable <plugin_name> ..."
372 elog
373}
374
375has_vdr() {
376 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
377}
378
379## exported functions
141 380
142vdr-plugin_pkg_setup() { 381vdr-plugin_pkg_setup() {
143 # -fPIC is needed for shared objects on some platforms (amd64 and others) 382 # -fPIC is needed for shared objects on some platforms (amd64 and others)
144 append-flags -fPIC 383 append-flags -fPIC
145 384
153 392
154 # Pathes to includes 393 # Pathes to includes
155 VDR_INCLUDE_DIR="/usr/include/vdr" 394 VDR_INCLUDE_DIR="/usr/include/vdr"
156 DVB_INCLUDE_DIR="/usr/include" 395 DVB_INCLUDE_DIR="/usr/include"
157 396
158
159 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 397 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
160 LOCDIR="/usr/share/vdr/locale" 398 LOCDIR="/usr/share/vdr/locale"
161 if has_version ">=media-video/vdr-1.5.7"; then 399
162 USE_GETTEXT=1 400 if ! has_vdr; then
401 # set to invalid values to detect abuses
402 VDRVERSION="eclass_no_vdr_installed"
403 APIVERSION="eclass_no_vdr_installed"
404
405 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
406 einfo "VDR not found!"
163 else 407 else
164 USE_GETTEXT=0 408 # if vdr is required
409 die "VDR not found!"
165 fi 410 fi
166 411 return
412 fi
413
167 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 414 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
168 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 415 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
169 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 416 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
170 417
171 einfo "Building ${PF} against vdr-${VDRVERSION}" 418 einfo "Compiling against"
172 einfo "APIVERSION: ${APIVERSION}" 419 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
420}
421
422vdr-plugin_src_util() {
423
424 while [ "$1" ]; do
425
426 case "$1" in
427 all)
428 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
429 ;;
430 prepare|all_but_unpack)
431 vdr-plugin_src_util add_local_patch patchmakefile i18n
432 ;;
433 unpack)
434 base_src_unpack
435 ;;
436 add_local_patch)
437 cd "${S}" || die "Could not change to plugin-source-directory!"
438 vdr_add_local_patch
439 ;;
440 patchmakefile)
441 cd "${S}" || die "Could not change to plugin-source-directory!"
442 vdr_patchmakefile
443 ;;
444 i18n)
445 cd "${S}" || die "Could not change to plugin-source-directory!"
446 vdr_i18n
447 ;;
448 esac
449
450 shift
451 done
173} 452}
174 453
175vdr-plugin_src_unpack() { 454vdr-plugin_src_unpack() {
176 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 455 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
177 eerror "Wrong use of vdr-plugin.eclass." 456 eerror "Wrong use of vdr-plugin.eclass."
178 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 457 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
179 echo 458 echo
180 eerror "Please report this at bugs.gentoo.org." 459 eerror "Please report this at bugs.gentoo.org."
181 die "vdr-plugin_pkg_setup not called!" 460 die "vdr-plugin_pkg_setup not called!"
182 fi 461 fi
183 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 462 if [ -z "$1" ]; then
463 case "${EAPI:-0}" in
464 2)
465 vdr-plugin_src_util unpack
466 ;;
467 *)
468 vdr-plugin_src_util all
469 ;;
470 esac
471
472 else
473 vdr-plugin_src_util $@
474 fi
475}
476
477vdr-plugin_src_prepare() {
478 base_src_prepare
479 vdr-plugin_src_util prepare
480}
481
482vdr-plugin_src_compile() {
483 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
184 484
185 while [ "$1" ]; do 485 while [ "$1" ]; do
186 486
187 case "$1" in 487 case "$1" in
188 all_but_unpack) 488 copy_source)
189 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
190 ;;
191 unpack)
192 base_src_unpack
193 ;;
194 patchmakefile)
195 if ! cd "${S}"; then
196 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
197 ewarn "Perhaps you find one among these:"
198 cd "${WORKDIR}"
199 ewarn "$(/bin/ls -1 "${WORKDIR}")"
200 die "Could not change to plugin-source-directory!"
201 fi
202
203 einfo "Patching Makefile"
204 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
205 cp Makefile "${WORKDIR}"/Makefile.before
206
207 sed -i Makefile \
208 -e '1i\#Makefile was patched by vdr-plugin.eclass'
209
210 ebegin " Setting Pathes"
211 sed -i Makefile \
212 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
213 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
214 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
215 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
216 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
217 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
218 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
219 eend $?
220
221 ebegin " Converting to APIVERSION"
222 sed -i Makefile \
223 -e 's:^APIVERSION = :APIVERSION ?= :' \
224 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
225 -e '2i\APIVERSION = '"${APIVERSION}"
226 eend $?
227
228 ebegin " Correcting Compile-Flags"
229 sed -i Makefile \
230 -e 's:^CXXFLAGS:#CXXFLAGS:' \
231 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
232 eend $?
233
234 ebegin " Disabling file stripping"
235 sed -i Makefile \
236 -e '/@.*strip/d' \
237 -e '/strip \$(LIBDIR)\/\$@/d' \
238 -e '/^STRIP =/d' \
239 -e '/@.*\$(STRIP)/d'
240 eend $?
241
242 # Use a file instead of an variable as single-stepping via ebuild
243 # destroys environment.
244 touch ${WORKDIR}/.vdr-plugin_makefile_patched
245 ;;
246 add_local_patch)
247 cd "${S}"
248 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
249 echo
250 einfo "Applying local patches"
251 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
252 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
253 done
254 fi
255 ;;
256 i18n)
257 cd "${S}"
258 if [[ ${USE_GETTEXT} = 0 ]]; then
259 # Remove i18n Target if using older vdr
260 sed -i Makefile \
261 -e '/^all:/s/ i18n//'
262 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
263 einfo "Converting translations to gettext"
264
265 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
266 if [[ ! -x ${i18n_tool} ]]; then
267 eerror "Missing ${i18n_tool}"
268 eerror "Please re-emerge vdr"
269 die "Missing ${i18n_tool}"
270 fi
271
272 # call i18n-to-gettext tool
273 # take all texts missing tr call into special file
274 "${i18n_tool}" 2>/dev/null \
275 |sed -e '/^"/!d' \
276 -e '/^""$/d' \
277 -e 's/\(.*\)/trNOOP(\1)/' \
278 > dummy-translations-trNOOP.c
279
280 # if there were untranslated texts just run it again
281 # now the missing calls are listed in
282 # dummy-translations-trNOOP.c
283 if [[ -s dummy-translations-trNOOP.c ]]; then
284 "${i18n_tool}" &>/dev/null
285 fi
286
287 # now use the modified Makefile
288 mv Makefile.new Makefile
289 fi
290 esac
291
292 shift
293 done
294}
295
296vdr-plugin_copy_source_tree() {
297 pushd . >/dev/null
298 cp -r "${S}" "${T}"/source-tree
299 cd "${T}"/source-tree
300 cp "${WORKDIR}"/Makefile.before Makefile
301 sed -i Makefile \
302 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
303 -e 's:^CXXFLAGS:#CXXFLAGS:' \
304 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
305 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
306 popd >/dev/null
307}
308
309vdr-plugin_install_source_tree() {
310 einfo "Installing sources"
311 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
312 insinto "${destdir}-${PV}"
313 doins -r "${T}"/source-tree/*
314
315 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
316}
317
318vdr-plugin_src_compile() {
319 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
320
321 while [ "$1" ]; do
322
323 case "$1" in
324 prepare)
325 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 489 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
326 ;; 490 ;;
327 compile) 491 compile)
328 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 492 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
329 eerror "Wrong use of vdr-plugin.eclass." 493 eerror "Wrong use of vdr-plugin.eclass."
333 eerror "Please report this at bugs.gentoo.org." 497 eerror "Please report this at bugs.gentoo.org."
334 die "vdr-plugin_src_unpack not called!" 498 die "vdr-plugin_src_unpack not called!"
335 fi 499 fi
336 cd "${S}" 500 cd "${S}"
337 501
502 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
503
338 emake ${BUILD_PARAMS} \ 504 emake ${BUILD_PARAMS} \
339 ${VDRPLUGIN_MAKE_TARGET:-all} \ 505 ${BUILD_TARGETS} \
340 LOCALEDIR="${TMP_LOCALE_DIR}" \ 506 LOCALEDIR="${TMP_LOCALE_DIR}" \
507 LIBDIR="${S}" \
508 TMPDIR="${T}" \
341 || die "emake failed" 509 || die "emake failed"
342 ;; 510 ;;
343 esac 511 esac
344 512
345 shift 513 shift
366 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 534 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
367 doins "${mname}.patched" 535 doins "${mname}.patched"
368 536
369 fi 537 fi
370 538
539
540
371 cd "${S}" 541 cd "${S}"
372 insinto "${VDR_PLUGIN_DIR}" 542 insinto "${VDR_PLUGIN_DIR}"
373 doins libvdr-*.so.* 543 doins libvdr-*.so.*
374 544
375 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then 545 # create list of all created plugin libs
546 vdr_plugin_list=""
547 local p_name
548 for p in libvdr-*.so.*; do
549 p_name="${p%.so*}"
550 p_name="${p_name#lib}"
551 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
552 done
553
554 create_header_checksum_file ${vdr_plugin_list}
555 create_plugindb_file ${vdr_plugin_list}
556
557 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
376 einfo "Installing locales" 558 einfo "Installing locales"
377 cd "${TMP_LOCALE_DIR}" 559 cd "${TMP_LOCALE_DIR}"
378 insinto "${LOCDIR}" 560 insinto "${LOCDIR}"
379 doins -r * 561 doins -r *
380 fi 562 fi
398 580
399 if [[ -n ${VDR_RCADDON_FILE} ]]; then 581 if [[ -n ${VDR_RCADDON_FILE} ]]; then
400 insinto "${VDR_RC_DIR}" 582 insinto "${VDR_RC_DIR}"
401 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 583 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
402 fi 584 fi
403
404 create_header_checksum_file
405 create_plugindb_file
406}
407
408vdr-plugin_print_enable_command() {
409 ewarn "emerge --config ${PN} is deprecated"
410 elog
411 elog "To activate this vdr-plugin execute the following command:"
412 elog "\teselect vdr-plugin enable ${PN#vdr-}"
413 elog
414} 585}
415 586
416vdr-plugin_pkg_postinst() { 587vdr-plugin_pkg_postinst() {
417 vdr-plugin_print_enable_command 588 vdr-plugin_print_enable_command
418 589
425 596
426vdr-plugin_pkg_postrm() { 597vdr-plugin_pkg_postrm() {
427 delete_orphan_plugindb_file 598 delete_orphan_plugindb_file
428} 599}
429 600
430vdr-plugin_pkg_config_legacy() {
431 elog "Using old interface to gentoo-vdr-scripts-0.3.7"
432 if [[ -z "${INSTALLPLUGIN}" ]]; then
433 INSTALLPLUGIN="${VDRPLUGIN}"
434 fi
435
436 active=0
437 # First test if plugin is already inside PLUGINS
438 local conf=/etc/conf.d/vdr.plugins
439 exec 3<${conf}
440 while read -u 3 line; do
441 [[ ${line} == "" ]] && continue
442 [[ ${line:0:1} == "#" ]] && continue
443 set -- ${line}
444 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
445 done
446 exec 3<&-
447
448 if [[ $active == 0 ]]; then
449 elog "Adding ${INSTALLPLUGIN} to active plugins."
450
451 # The pure edit process.
452 echo "${INSTALLPLUGIN}" >> "${conf}"
453 else
454 elog "${INSTALLPLUGIN} already activated"
455 echo
456 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
457 if [[ "${answer}" != "yes" ]]; then
458 elog "aborted"
459 return
460 fi
461 elog "Removing ${INSTALLPLUGIN} from active plugins."
462
463 # The pure edit process
464 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
465 fi
466}
467
468vdr-plugin_pkg_config() { 601vdr-plugin_pkg_config() {
602 ewarn "emerge --config ${PN} is no longer supported"
469 vdr-plugin_print_enable_command 603 vdr-plugin_print_enable_command
470
471 einfo "Calling this now"
472 eselect vdr-plugin enable "${PN#vdr-}"
473} 604}
474 605
475fix_vdr_libsi_include() 606case "${EAPI:-0}" in
476{ 607 2)
477 einfo "Fixing include of libsi-headers" 608 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
478 local f 609 ;;
479 for f; do 610 *)
480 sed -i "${f}" \
481 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
482 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
483 done
484}
485
486EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 611 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
612 ;;
613esac

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.70

  ViewVC Help
Powered by ViewVC 1.1.20